  subroutine cluster_check (nsou, max_sou, x, y, rate, scut, cflag)

  implicit none

  integer, intent(in) :: nsou, max_sou
  real, dimension(max_sou), intent(in) :: x, y, rate
  real, intent(in) :: scut
  integer, dimension(max_sou), intent(out) :: cflag

  real :: dist, scut2, ratem
  integer :: i, j, k, l, nclu, im 
  integer, dimension(max_sou) :: point 
  real, parameter :: eps = 1e-5
  logical, dimension(max_sou) :: new

  scut2 = scut**2
  cflag = 0

! set cfalg if source has two or more neighbours within distance scut

  do i = 1, nsou
    if (cflag(i) < 9) then
      k =  1
      point(k) = i  
       
      new = .true.
      new(i) = .false.
      ratem = -1.0
      im = -1
      l = 1
      do while (l <= k) 

        nclu = 0
        do j = 1, nsou
          dist = (x(point(l))-x(j))**2 + (y(point(l))-y(j))**2
          if (dist > eps .and. dist < scut2) then
            if (new(j)) then
              k = k + 1
              point(k) = j
              new(j) = .false.
            end if
            nclu = nclu+1
          end if  
        end do

        if (nclu > 1) then
          cflag(point(l)) = 9
          if (rate(point(l)) > ratem) then
            ratem = rate(point(l))
            im = point(l)
          end if
        end if

        l = l+1
      end do

      if (im > 0) cflag(im) = 1

    end if
  end do

  end subroutine cluster_check

